* Demonstration Abhaengigkeit Beta von Schiefe
version 6.0

preserve

* Moment bitte, ich berechne 1000 Regressionen
quietly {

    * Ertelle Daten
    clear
    set obs 1000

    * X1-Variable (Konstante Schiefe)
    gen X1 = 0 in 1/500
    replace X1 = 1 in 501/1000
    sum X1
    local sx1 = r(sd)

    * Fehlerterm (Standardnormalverteilt)
    set seed 731
    gen error = invnorm(uniform())

    * Daten zufllig sortieren um Multikollinearitt zu vermeiden
    gen r = uniform()
    sort r

    * Leere X2 und Y erzeugen
    gen X2 = .
    gen Y = .

    * Postfile
    postfile betas b1 b2 promill beta1 beta2 using betas, replace

    * Schleife
    local i 2
    while `i'<= 999 {
        * Erzeuge X2
        replace X2 = 0
        replace X2 = 1 in 1/`i'
        summarize X2, detail
        local sx2 = r(sd)

        * Generiere Y mit Regressionskoeffizienten von 2
        replace Y = 2 * X1 + 2 * X2 + error
        summarize Y
        local sy = r(sd)

        * Berechne Regression
        regress Y X1 X2

        * Speichere Ergebnisse
        post betas (_b[X1]) (_b[X2]) (`i') (_b[X1] * `sx1'/`sy') (_b[X2] * `sx2'/`sy')
        local i = `i' +1
    }
    postclose betas

    use betas, clear

    * Graphikbeschriftung
    gen X1 = beta1 if promill == 2
    replace X1= beta1 if promill == 250
    replace X1 = beta1 if promill == 500
    replace X1 = beta1 if promill == 750
    replace X1 = beta1 if promill == 999
    lab var X1 "X1: nichtvariierte Schiefe"

    gen X2 = beta2 if promill == 2
    replace X2= beta2 if promill == 250
    replace X2 = beta2 if promill == 500
    replace X2 = beta2 if promill == 750
    replace X2 = beta2 if promill == 999
    lab var X2 "X2: variierte Schiefe"

    lab var promill "Anteil Wert 1 an X2 (in 0/00)"

    graph beta1 X1 beta2 X2 promill, c(l.l.) s(iOiT) pen(2233) bor /*
    */ l1t(Beta-Koeffizient) title(Betas in Y = 2*X1 + 2*X2 + e) /*
    */ xlab(0(250)1000) ylab xline(500)
}

restore

exit
