program define denscomp
    version 6.0
    syntax varname [if] [in], by(varname) /*
     */ at(varname numeric) [ TItle(string) L1Title(string) * ]

    * if/in
    if "`if'" ~= "" | "`in'" ~= "" {
        preserve
        quietly keep `if' `in'
    }

    * How many kategories of byvar
    tempvar groups
    sort `by'
    quietly by `by': gen `groups' = 1 if _n == 1
    quietly replace `groups' = sum(`groups')
    local K = `groups'[_N]

    * Check Graph Options
    if "`options'" ~= "" {
        set graph off
        local k 1
        while  `k' <= `K' {
            tempvar _g`k'
            quietly gen `_g`k'' = `groups' == `k'
            local dummies "`dummies' `_g`k''"
            local k = `k' + 1
        }
        capture graph `dummies' `at', `options'
        set graph on
        if _rc ~= 0 {
                display in red "options invalid"
                exit _rc
        }
    }

    * Calculate Values
    local i 1
    while `i' <= `K' {
        tempvar fx`i'
        kdensity `varlist' if `groups' ==`i', gen(`fx`i'') at(`at') nograph
        local yvars "`yvars' `fx`i''"
        quietly summarize `by' if `groups' == `i'
        local lab`i': label (`by') `r(mean)'
        lab var `fx`i'' "`lab`i''"
        local i = `i' + 1
    }

   * Graph Defaults
   local title = cond("`title'" == "", "`varlist' nach `by'","`title'")
   local l1title = cond("`l1title'" == "", "Dichte","`l1title'")

   * Graph
    graph `yvars' `at', ti("`title'") l1t("`l1title'") `options' sort
end
exit
