* Schematische Darstellung der fixed-effects Regression

preserve

* Datensatz erzeugen
clear
input i t X Y
 1 1 2 6
 1 2 3 5.7
 1 3 4 5
 2 1 4 15
 2 2 5 11
 2 2 6 6
end

* Normale Regression
regress Y X
predict yhat

* Fixed effects Regression
tabulate i, gen(pers_d)
regress Y X pers_d1 pers_d2
predict yhfixed
predict yh_1 if i == 1
predict yh_2 if i == 2

* Graphik
gen y1 = Y if i == 1
gen y2 = Y if i == 2
lab var y1 "Y_i=1"
lab var y2 "Y_i=1"
lab var yhat "Standard OLS Pred."
lab var yhfixed "Fixed Effects Pred."
graph y1 y2 yhfixed yhat yh_1 yh_2 X, bor c(...lll) s(OSTpiii)/*
*/ pen(223333) saving(fixed, replace)

restore

exit




